#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#include <windows.h>
#include "devioctl.h"
#include "ntddscsi.h"



void DumpMem(void* buf, int size) { // 蔲
	unsigned char *p = (unsigned char*)buf ;
	
	char bin[100] ;
	char ascii[100] ;
	ascii[0] = '\0' ;
	bin[0] = '\0' ;
	char temp[100] ;

	for (int i=0; i<=size; i++) {
		if (((i>15) && (i%16 ==0))||i==size) {
			printf("%03x: %s %s\n", i-16, bin, ascii) ;
			bin[0] = '\0' ;
			ascii[0] = '\0' ;
		}

		if (i==size) break ; // 邢

		sprintf(temp, "%02x ", p[i])  ;
		strcat(bin, temp) ;
		
		if (isalnum(p[i])) {
			temp[0] = p[i] ;
		} else {
			temp[0] = '.' ;
		}
		temp[1] = '\0' ;
		strcat(ascii, temp) ;
	}
	
}


#pragma pack(push, 1)
typedef struct {
	SRB_IO_CONTROL sic ;
	USHORT port ;
	USHORT maybe_always1 ;
	ULONG unknown[5] ;
	//IDENTIFY_DEVICE id_data ;
	WORD id_data[256] ;
} SilIdentDev ;
#pragma pack(pop)


void GetIdentifyFromSiliconImage(int num) {
	char szBusPathBody[MAX_PATH] ;

	bool fDDD_done = false ;
	
	if (num == 3512) num = 3112 ;
	
	if (32 > num) { // SCSIn
		sprintf(szBusPathBody, "Scsi%d:", num) ;
	} else { // Sil
		sprintf(szBusPathBody, "tempBusSil%d", num) ;
		char szSilDeviceName[MAX_PATH] ;
		sprintf(szSilDeviceName, "\\Device\\Scsi\\SI%d1", num) ; // 1tƂɒ
		if (DefineDosDevice(DDD_RAW_TARGET_PATH, szBusPathBody, szSilDeviceName) ) {
			// ok
			fDDD_done = true ;
		} else {
			printf("DefineDosDeviceɎs܂BGetLastError=%d\n", GetLastError()) ;
			return ;
		}
	}
	
	char szBusPath[MAX_PATH] ;
	sprintf(szBusPath, "\\\\.\\%s", szBusPathBody) ;
	HANDLE hDrive = CreateFile(szBusPath, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL) ;
	if (INVALID_HANDLE_VALUE != hDrive) {
		for (int port=0; port<4; port++) {
			
			SilIdentDev sid ;
			memset(&sid, 0, sizeof(sid)) ;
			
			sid.sic.HeaderLength = sizeof(SRB_IO_CONTROL) ;
			memcpy(sid.sic.Signature, "CMD_IDE ", 8);
			sid.sic.Timeout = 5 ;
			sid.sic.ControlCode = CTL_CODE(FILE_DEVICE_CONTROLLER, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS) ;
			sid.sic.ReturnCode = 0xffffffff ;
			sid.sic.Length = sizeof(sid) - offsetof(SilIdentDev, port) ;
			sid.port = port ; // 0 or 1 ;
			sid.maybe_always1 = 1 ;
			
			DWORD dwReturnBytes ;
			if(DeviceIoControl(hDrive, IOCTL_SCSI_MINIPORT, &sid, sizeof(sid), &sid, sizeof(sid), &dwReturnBytes, NULL)) {
				printf("Port %d\n", port) ;
				DumpMem(&sid.id_data, sizeof(sid.id_data)) ;
				printf("-----------------------------------------\n") ;
			}
		}
	} else {
		printf("CreateFile(%s)Ɏs܂BGetLastError=%d\n", szBusPath, GetLastError()) ;
	}
	
	if (fDDD_done) {
		DefineDosDevice(DDD_REMOVE_DEFINITION, szBusPathBody, NULL) ;

	}
	

}

int main(int argc, char* argv[])
{
	if (argc == 2) {
		GetIdentifyFromSiliconImage(atoi(argv[1])) ;
		
	} else {
		printf("SCSIoXԍ(0`)  SiliconImagě^Ԃ̐(3512)w肵Ă.\n") ;
	}
	
	return 0;
}

